#if !defined(AFX_RC4__H__INCLUDED_)
#define AFX_RC4__H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



__inline void RC4(LPBYTE lpBuff,SIZE_T dwBuffSize,LPBYTE lpKey,SIZE_T dwKeySize)
{// RC4
// www.codeproject.com/cpp/crypt_routine.asp%3Fdf%3D100%26forumid%3D4418%26exp%3D0%26select%3D251879+RC4+c%2B%2B+source+DWORD&hl=ru&gl=ru&ct=clnk&cd=2
// http://www.thecodeproject.com/cpp/crypt_routine.asp
// http://forum.ixbt.com/topic.cgi?id=40:3020

	//we will consider size of sbox 256 bytes
    //(extra byte are only to prevent any mishep just in case)
    BYTE temp;
	BYTE Sbox[260]={0},Sbox2[260]={0};
    SIZE_T i,j,t,x;

    i=j=t=x=0;
    temp=0;

    //initialize sbox i
    for(i=0;i<256;i++) Sbox[i]=(BYTE)i;

    j=0;
    //whether user has sent any inpur lpKey
    //initialize the sbox2 with user lpKey
    for(i=0;i<256;i++)
    {
        if (j==dwKeySize) j=0;
        Sbox2[i]=lpKey[j++];
    }    

    j=0; //Initialize j
    //scramble sbox1 with sbox2
    for(i=0;i<256;i++)
    {
        j=(j+(unsigned long)Sbox[i]+(unsigned long)Sbox2[i]) % 256U;
        temp=Sbox[i];                    
        Sbox[i]=Sbox[j];
        Sbox[j]=temp;
    }

    i=j=0;
    for(x=0;x<dwBuffSize;x++)
    {
        //increment i
        i=(i+1U)%256U;
        //increment j
        j=(j+(unsigned long)Sbox[i])%256U;

        //Scramble SBox #1 further so encryption routine will
        //will repeat itself at great interval
        temp=Sbox[i];
        Sbox[i]=Sbox[j];
        Sbox[j]=temp;

        //Get ready to create pseudo random  byte for encryption lpKey
        t=((unsigned long)Sbox[i]+(unsigned long)Sbox[j])%256U;

        //get the random byte
        //xor with the data and done
        lpBuff[x]=(lpBuff[x]^Sbox[t]);
    }    
}



#endif // !defined(AFX_RC4__H__INCLUDED_)


